/**
 *
 */
!function(undefined) {
	var NAMESPACE = 'WebViewJavascriptBridge';
	var API_NAMESPACE = '__JavascriptBridge__';
	var API_FREQUENCY = 200;

	var context = window[NAMESPACE] = {};
	var api = window[API_NAMESPACE] || null;
	if (!api) {
		/*return alert('发生错误, 未找到 api 对象!');*/
		return;
	}

	var jsMethodMap = {};
	var responseCallbacks = {};
	var uniqueId = 1;
	
	context.addJavascriptMethod = function(method, func) {
		jsMethodMap[method] = function(params, responseCallbackDoNothing) {
			func(params);
		}
	}

	context.registerHandler = function(method, handler) {
		jsMethodMap[method] = handler;
	}
	function responseCallbackDoNothing(result) {
	}

	context.require = function(cmd, params, callback) {
		params = params || {};
		var callbackId = 'no_cb';
		if (callback) {
		    callbackId = 'cb_' + (uniqueId++) + '_' + new Date().getTime()
			responseCallbacks[callbackId] = callback
		} 
		api.require(cmd, callbackId, JSON.stringify(params));
	}
	
	context.callHandler = context.require;

	context.send = function(params, callback) {
		if (context._messageHandler) {
			try {
				context._messageHandler(params, callback);
			} catch (exception) {
				if (typeof console != 'undefined') {
					console.log(
					        "WebViewJavascriptBridge: WARNING: javascript handler threw.",
					        message, exception)
				}
			}
		}
	}

	var executeCommand = function(cmdObj) {
		var method = jsMethodMap[cmdObj.cmd];
		if (method instanceof Function) {
			var respCallback = function(result) {
			    // console.log("XXX result = " + result);
				api.setResult(cmdObj.serial, JSON.stringify(result));
			}
			method.call(window, cmdObj.params, respCallback);
		}
	}

	var listener = {
		_timer : 0,
		_timerFunc : function() {
			var cmdsStr = api.getCommands();
			var cmdList = JSON.parse(cmdsStr);
			if (cmdList.length) {
				for ( var i in cmdList) {
				    executeCommand(cmdList[i]);
				}
			}
			listener.run();
		},
		run : function() {
			this._timer = setTimeout(this._timerFunc, API_FREQUENCY);
		},
		stop : function() {
			clearTimeout(this._timer);
			this._timer = 0;
		}
	};

	context.init = function(messageHandler) {
		if (context._messageHandler) {
			throw new Error('WebViewJavascriptBridge.init called twice');
		}

		context._messageHandler = messageHandler;
		
		context.addJavascriptMethod('handleResponseFromJava', function(params) {
		    var responseCallback = responseCallbacks[params.callbackId];
			if (!responseCallback) { return;}
			
			responseCallback(params.result);
			
			delete responseCallbacks[params.callbackId];
		});

		listener.run();
	}

	var readyEvent = document.createEvent('Events')
	readyEvent.initEvent('WebViewJavascriptBridgeReady')
	readyEvent.bridge = context;
	document.dispatchEvent(readyEvent)
}();